//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#include <cstdlib>
#include <iostream>

using namespace std;

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

template<typename T>
class MyQueue
{
public:
  
  MyQueue() { maxnum = 100; curnum = 0; A = new T[maxnum]; }    // make an empty queue

  void enqueue(T);              // put item on the queue
  T dequeue();                   // take item off

  bool empty() { return curnum == 0; }
  bool full() { return curnum == maxnum; }
  int size() { return curnum; }
  void error(string s) { cout << "Error: " << s << endl; exit(1); }

private:

  T *A;
  int maxnum;
  int curnum;

};

//----------------------------------------------------------------------------

// item is new top of queue

template<typename T>
void MyQueue<T>::enqueue(T theData)
{
  if (!full()) {
    for (int i = curnum; i > 0; i--)
      A[i] = A[i-1];
    A[0] = theData;
    curnum++;
  }
  else
    error("Tried to enqueue on full queue");
}

//----------------------------------------------------------------------------

// return item currently on top of queue

template<typename T>
T MyQueue<T>::dequeue()
{
  if (!empty())
    return A[--curnum];
  else
    error("Tried to dequeue from empty queue");
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

void char_test()
{
  char next;

  MyQueue<char> s;

  cout << "Enter some text\n";
  cin.get(next);
  while (next != '\n') {
    s.enqueue(next);
    cin.get(next);
  }

  cout << "Written forward that is:\n";

  while (!s.empty())
    cout << s.dequeue();
  cout << "\n";

}

//----------------------------------------------------------------------------

void string_test()
{
  string next;
  char c;

  MyQueue<string> s;

  cout << "Enter a sentence or two\n";

  while (cin >> next) {

    s.enqueue(next);

    // was that the last word on the line?

    c = cin.get();

    if (c == '\n')
      break;
    else
      cin.putback(c);

  }

  cout << "Written forward that is:\n";
  
  while (!s.empty())
    cout << s.dequeue() << " ";
  cout << "\n";

}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

int main(int argc, char** argv)
{
  char_test();
  string_test();

  return 1;
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
